from sys import exit, stdin
# Lisaoptimisatsioon kiirema lugemise tarbeks
#input = stdin.readline

# Sisend
n, m = map(int, input().split())
naabrid = [[] for _ in range(n)]

for _ in range(m):
    # Serv
    a, b = map(int, input().split())
    a -= 1
    b -= 1
    naabrid[a].append(b)
    naabrid[b].append(a)

def otsi_paaritu_tsyk(jarjekord, halb = set()):
    # Otsi paaritu tsükkel, ignoreerides servi hulgast `halb`
    eelmine = [-1 for _ in range(n)]
    sygavus = [0 for _ in range(n)]
    pinu = []
    for alg in jarjekord:
        if eelmine[alg] != -1:
            continue
        pinu.append((alg, alg))
        while len(pinu) > 0:
            idx, eel = pinu.pop()
            if eelmine[idx] == -1:
                # Uus tipp
                # DFS
                eelmine[idx] = eel
                if idx != eel:
                    sygavus[idx] = sygavus[eel] + 1
                for muu in naabrid[idx]:
                    if muu != eel and (idx, muu) not in halb:
                        pinu.append((muu, idx))
            else:
                # Juba külastatud tipp -> tsükkel
                # Kontrollime tsükli paarsus
                if (sygavus[eel] - sygavus[idx]) % 2 == 0:
                    # Paaritu tsükkel
                    tsyk = [eel]
                    praegu = eel
                    while praegu != idx:
                        praegu = eelmine[praegu]
                        tsyk.append(praegu)
                    return tsyk, None
    # Ei leidnud tsüklit
    return None, sygavus

# Esimese tsükli otsimisel on järjekorrast ükskõik
tsyk_a, sygavus = otsi_paaritu_tsyk(range(n))
if tsyk_a is not None:
    l = len(tsyk_a)
    halb = set()
    for i, x in enumerate(tsyk_a):
        y = tsyk_a[(i + 1) % l]
        halb.add((x, y))
        halb.add((y, x))
    # Veendume, et kui teist tsüklit ei leidu, siis paarisarvuline
    # sügavus on tsüklil oleval tipul
    jarjekord = list(tsyk_a)
    tsyk_hulk = set(tsyk_a)
    jarjekord.extend(i for i in range(n) if i not in tsyk_hulk)
    tsyk_b, sygavus = otsi_paaritu_tsyk(jarjekord, halb)
    if tsyk_b is not None:
        print("1")
        print(len(tsyk_a), len(tsyk_b))
        print(" ".join(str(x + 1) for x in tsyk_a))
        print(" ".join(str(x + 1) for x in tsyk_b))
        exit()

# Pole kahte ühise servata paaritut tsüklit
# Värvime
varvid = [0 for _ in range(n)]
if tsyk_a is not None:
    # Värvime ainsa tsükli värvidega 1, 2 ja 3
    for i, x in enumerate(tsyk_a):
        varvid[x] = [1, 2][i % 2]
    # Liitekohas on sama värv kõrvuti
    varvid[tsyk_a[0]] = 3

# Ülejäänud tipud värvime "sügavuse" põhjal
# Paarissügavustel on värvid 1, 2 ja 3
# Paaritutel sügavustel ainult värv 4
for i in range(n):
    if varvid[i] == 0:
        varvid[i] = [1, 4][sygavus[i] % 2]

print("2")
print(" ".join(map(str, varvid)))
