#include <iostream>
#include <vector>

using namespace std;

const int maxint = 1001;
vector<int> graaf[maxint];
bool parast[maxint][maxint] = {{0}};
int palju[maxint] = {0};
bool kaidud[maxint];

void kai_labi(int a, int u) {
    kaidud[u] = 1;
    if (a != u) {
        parast[a][u] = 1;
        palju[a]++;
    }
    int i;
    for (i = 0; i < graaf[u].size(); i++) {
        int v = graaf[u][i];
        if (!kaidud[v]) {
            kai_labi(a, v);
        }
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    int i, j;
    for (i = 0; i < m; i++) {
        int k;
        cin >> k;
        int eel = 0;
        for (j = 0; j < k; j++) {
            int a;
            cin >> a;
            if (eel > 0) {
                graaf[eel].push_back(a);
            }
            eel = a;
        }
    }
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++) {
            kaidud[j] = 0;
        }
        kai_labi(i, i);
    }
    int vastus[n];
    for (i = n - 1; i >= 0; i--) {
        for (j = 1; j <= n; j++) {
            if (palju[j] == 0) {
                break;
            }
        }
        vastus[i] = j;
        palju[j]--;
        for (j = 1; j <= n; j++) {
            if (parast[j][vastus[i]]) {
                parast[j][vastus[i]] = 0;
                palju[j]--;
            }
        }
    }
    for (i = 0; i < n; i++) {
        cout << vastus[i] << " ";
    }
}
