#! /bin/env python3

import argparse
parser = argparse.ArgumentParser()
parser.add_argument("rows", type=int)
parser.add_argument("cols", type=int)
parser.add_argument("seed", default="abrakadabra")

args = parser.parse_args()

import random
from string import ascii_lowercase as alpha

random.seed(args.seed)

text = "".join(random.choices(alpha, k = args.rows * args.cols))

print(f"{args.rows} {args.cols}")
print(text)
