// O(P) tööajaga lahendus

#include <iostream>
#include <algorithm>
using namespace std;

int p, h1, h2, k2, h3, k3; // sisendandmed
int parim_hind; // seni parim lahendus

// kontrollib varianti osta n3 suurt ja n2 väikest pakki
// ja lisaks nii palju üksikuid komme kui veel juurde vaja
void kontrolli(int n3, int n2) {
	int n1 = max(p - n3 * k3 - n2 * k2, 0);
	parim_hind = min(parim_hind, n1 * h1 + n2 * h2 + n3 * h3);
}

int main() {
	// loeme sisendi
	cin >> p;
	cin >> h1;
	cin >> h2 >> k2;
	cin >> h3 >> k3;

	// seni parim tulemus
	parim_hind = p * h1;

	// vaatame läbi kõik võimalikud suurte pakkide arvud
	for (int n3 = 0; n3 * k3 < p + k3; ++n3) {
		// kaalume varianti osta kõik ülejäänu üksikute kommidena
		kontrolli(n3, 0);
		// kaalume varianti osta lisaks nii palju väikseid pakke, et need kõik ära kuluks
		int n2 = max(p - n3 * k3, 0) / k2;
		kontrolli(n3, n2);
		// kaalume varianti osta üks väike pakk rohkem
		kontrolli(n3, n2 + 1);
	}

	// väljastame vastuse
	cout << parim_hind << '\n';
}
