from sys import exit
from fractions import Fraction

n = int(input())
def loe_pt():
    return tuple(map(int, input().split()))
kaitsjad_alg = [loe_pt() for _ in range(n)]
ryndaja = loe_pt()
varav = loe_pt()

def vasta(vastus):
    print(vastus)
    exit()

if n == 1:
    vasta("JAH")

def rist(a, b):
    return a[0] * b[1] - a[1] * b[0]

inf = 10**12
def nurk(p):
    # Vastupäeva alates (1, 0)
    x, y = p
    s = 0
    if y < 0:
        x = -x
        y = -y
        s = 2
    if x == 0:
        return (s, inf)
    return (s + (0 if x > 0 else 1), Fraction(y, x))

def osa(ryndaja, varav):
    # Teisendame kõik koordinaadid nii, et ründaja on nullpunkt
    kaitsjad = [(x - ryndaja[0], y - ryndaja[1]) for x, y in kaitsjad_alg]
    varav = (varav[0] - ryndaja[0], varav[1] - ryndaja[1])

    # Sorteerime kaitsjad nurga järgi
    kaitsjad.sort(key=nurk)
    

    # Otsime, millisele indeksile värav kaitsjate suhtes asetub
    # Tahame, et järgmisel indeksil olev kaitsja oleks väravast
    # esimene vastupäeva liikudes (ja mitte sama nurga all)
    lo = 0
    hi = n
    nv = nurk(varav)
    while hi - lo > 1:
        m = (hi + lo) // 2
        if nurk(kaitsjad[m]) > nv:
            hi = m
        else:
            lo = m
    idx = lo
    if lo == 0:
        if nurk(kaitsjad[0]) > nv:
            idx = n - 1

    # Kontrollime, ega kaks eelmist pole samal joonel väravaga
    # Kui selliseid kaitsjaid, kes on ründaja ja väravaga samas sihis, on vähemalt kaks, siis ei saa
    if n > 1 and nurk(kaitsjad[idx]) == nv == nurk(kaitsjad[idx - 1]):
        return

    # Kontrollime kahte vahemiku: lähim paremalt vahemikus ja lähim vasakult vahemikus
    def proovi(a, b):
        a = a % n
        b = b % n
        # Kontrollime, kas b on a-st rangelt lähemal päripäeva
        if rist(kaitsjad[a], kaitsjad[b]) < 0:
            vasta("JAH")
        if nurk(kaitsjad[a]) == nurk(kaitsjad[b]):
            vasta("JAH")
    proovi(idx, idx + 2)
    proovi(idx - 1, idx + 1)
# Kontrollime
osa(ryndaja, varav)
# Teistpidi ka
osa(varav, ryndaja)
vasta("EI")