#!/usr/bin/env python3

# Input validator

import sys
import re

pat = re.compile('[a-z]*')

st = {2, 3, 4, 5, 6, 7}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, m = (int(x) for x in fi.readline().split())
if 1 > n or n > 100:
	sys.exit('N out of range')
if 1 > m or m > 100:
	sys.exit('M out of range')
fo.write(f'{n} {m}\n')
if n != 1:
	st.discard(2)
if m != 1:
	st.discard(3)
if m != 2:
	st.discard(4)
if m != 3:
	st.discard(5)
if 2 > n or n > 3:
	st.discard(6)

s = fi.readline().strip()
if len(s) != n * m:
	sys.exit('Invalid length of S')
if not pat.match(s):
	sys.exit('Invalid characters in S')
fo.write(f'{s}\n')

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
	print('subtasks:', *st)
