# O(P) tööajaga lahendus

# loeme sisendi
P = int(input())
H1 = int(input())
H2, K2 = (int(x) for x in input().split())
H3, K3 = (int(x) for x in input().split())

# seni parim lahendus
parim_hind = P * H1

# kontrollib varianti osta n3 suurt ja n2 väikest pakki
# ja lisaks nii palju üksikuid komme kui veel juurde vaja
def kontrolli(N3, N2):
    global parim_hind
    N1 = max(P - N3 * K3 - N2 * K2, 0)
    parim_hind = min(parim_hind, N1 * H1 + N2 * H2 + N3 * H3)

# vaatame läbi kõik võimalikud suurte pakkide arvud
for N3 in range(P // K3 + 2):
    # kaalume varianti osta kõik ülejäänu üksikute kommidena
    kontrolli(N3, 0)
    # kaalume varianti osta lisaks nii palju väikseid pakke, et need kõik ära kuluks
    N2 = max(P - N3 * K3, 0) // K2
    kontrolli(N3, N2)
    # kaalume varianti osta üks väike pakk rohkem
    kontrolli(N3, N2 + 1)

# väljastame vastuse
print(parim_hind)
