// O(P^2) tööajaga lahendus

#include <iostream>
#include <algorithm>
using namespace std;

int main() {
	// loeme sisendi
	int p, h1, h2, k2, h3, k3;
	cin >> p;
	cin >> h1;
	cin >> h2 >> k2;
	cin >> h3 >> k3;

	// seni parim tulemus
	int parim_hind = p * h1;

	// vaatame läbi kõik võimalikud suurte pakkide arvud
	for (int n3 = 0; n3 * k3 < p + k3; ++n3) {
		// vaatame läbi kõik võimalikud väikeste pakkide arvud
		for (int n2 = 0; n3 * k3 + n2 * k2 < p + k2; ++n2) {
			// puuduva hulga ostame üksikute kommidena
			int n1 = max(p - n3 * k3 - n2 * k2, 0);
			parim_hind = min(parim_hind, n1 * h1 + n2 * h2 + n3 * h3);
		}
	}

	// väljastame vastuse
	cout << parim_hind << '\n';
}
