// O(P^3) tööajaga lahendus

#include <iostream>
#include <algorithm>
using namespace std;

int main() {
	// loeme sisendi
	int p, h1, h2, k2, h3, k3;
	cin >> p;
	cin >> h1;
	cin >> h2 >> k2;
	cin >> h3 >> k3;

	// seni parim tulemus
	int parim_hind = p * h1;

	// leiame parima hinna kõigi variantide läbivaatusega
	for (int n1 = 0; n1 <= p; ++n1) {
		for (int n2 = 0; n2 <= p / k2 + 1; ++n2) {
			for (int n3 = 0; n3 <= p / k3 + 1; ++n3) {
				if (n1 + n2 * k2 + n3 * k3 >= p) {
					parim_hind = min(parim_hind, n1 * h1 + n2 * h2 + n3 * h3);
				}
			}
		}
	}

	// väljastame vastuse
	cout << parim_hind << '\n';
}
