# O(P^3) tööajaga lahendus

# loeme sisendi
P = int(input())
H1 = int(input())
H2, K2 = (int(x) for x in input().split())
H3, K3 = (int(x) for x in input().split())

# seni parim tulemus
parim_hind = P * H1

# leiame parima hinna kõigi variantide läbivaatusega
for N1 in range(P + 1):
    for N2 in range(P // K2 + 2):
        for N3 in range(P // K3 + 2):
            if N1 + N2 * K2 + N3 * K3 >= P:
                parim_hind = min(parim_hind, N1 * H1 + N2 * H2 + N3 * H3)

# väljastame vastuse
print(parim_hind)
