// laiendatud lahendus, mis kontrollib lisaks, kas
// - optimaalne lahendus on ühene
// - leidub optimaalne lahendus, mis ostab täpselt nõutud arvu komme

#include <iostream>
#include <algorithm>
using namespace std;

int p, h1, h2, k2, h3, k3;
int parim_hind = -1;
int parim_kordi = 0;
int varuga_kordi = 0;

void kontrolli(int n3, int n2) {
	int n1 = max(p - n3 * k3 - n2 * k2, 0);
	int hind = n1 * h1 + n2 * h2 + n3 * h3;
	if (parim_hind == -1 or parim_hind > hind) {
		parim_hind = hind;
		parim_kordi = 0;
		varuga_kordi = 0;
	}
	if (parim_hind == hind) {
		++parim_kordi;
		if (n1 + n2 * k2 + n3 * k3 > p) {
			++varuga_kordi;
		}
	}
}

int main() {
	cin >> p;
	cin >> h1;
	cin >> h2 >> k2;
	cin >> h3 >> k3;

	for (int n3 = 0; n3 * k3 < p + k3; ++n3) {
		kontrolli(n3, 0);
		int n2 = max(p - n3 * k3, 0) / k2;
		if (n2 > 1) kontrolli(n3, n2 - 1);
		if (n2 > 0) kontrolli(n3, n2);
		kontrolli(n3, n2 + 1);
	}

	cout << parim_hind << '\n';
	cerr << parim_hind << ' ' <<
		(parim_kordi == 1 ? "ühene" : "mitteühene") << ' ' <<
		(varuga_kordi == parim_kordi ? "varuga" : "täpne") << '\n';
}
