#include <cstdint>
#include "testlib.h"

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);
  
  int h = opt<int>("h");
  int reps = opt<int>("reps");

  vector<int> arr (1, 0);
  for (int k = 0; k < reps; k++) {
    // +h +h -1 +0 +0
    arr.push_back(arr.back() + h);
    arr.push_back(arr.back() + h);
    arr.push_back(arr.back() - 1);
    arr.push_back(arr.back());
    arr.push_back(arr.back());
  }

  int n = (int) arr.size() - 1;
  cout << n << " " << 2 << " " << h - 1 << " " << 3 << '\n';
  for (int i = 0; i <= n; i++) {
    cout << arr[i];
    if (i != n)
      cout << " ";
  }
  cout << '\n';
}
