#include <cstdint>
#include "testlib.h"

using namespace std;

const int MAX_N = 100'000;
const int MAX_A = 1'000'000'000;
const int MAX_P = 1'000'000'000;

int main (int argc, char **argv) {
  registerValidation(argc, argv);

  int n = inf.readInt(1, MAX_N, "n");
  inf.readSpace();
  inf.readInt(1, n, "m");
  inf.readSpace();
  inf.readInt(1, MAX_P, "p");
  inf.readSpace();
  inf.readInt(1, MAX_P, "q");
  inf.readEoln();

  for (int i = 0; i <= n; i++) {
    inf.readInt(0, MAX_A, "Ai");
    if (i == n)
      inf.readEoln();
    else
      inf.readSpace();
  }
  inf.readEof();

  if (validator.group() == "quartic")
    ensure(n <= 100);
  if (validator.group() == "quadratic")
    ensure(n <= 1000);
}
