import sys

INF = 10**9

FLAT = 0
RISE = 1
FALL = 2
names = ["TASANE", "TOUSEV", "LASKUV"]

n, m, p, q = map(int, input().split())
arr = list(map(int, input().split()))

ok = [[0 for i in range(n + 1)] for j in range(n + 1)]

for k in range(1, n + 1):
    for l in range(n - k + 1):
        r = l + k

        if abs(arr[r] - arr[l]) * q < p:
            ok[l][r] |= 1 << FLAT
        if r - l >= m and (arr[r] - arr[l]) * q >= p * (r - l):
            ok[l][r] |= 1 << RISE
        if r - l >= m and (arr[l] - arr[r]) * q >= p * (r - l):
            ok[l][r] |= 1 << FALL

        for L in range(l, r + 1):
            for R in range(l + 1, r + 1):
                if ok[L][R] & 1 << RISE:
                    ok[l][r] &= 1 << RISE
                if ok[L][R] & 1 << FALL:
                    ok[l][r] &= 1 << FALL

dp = [[INF for _ in range(3)] for __ in range(n + 1)]
last = [[(0, 0) for _ in range(3)] for __ in range(n + 1)]

for k in range(3):
    dp[0][k] = 0

for i in range(n):
    for k in range(3):
        if dp[i][k] == INF:
            continue

        for j in range(i + 1, n + 1):
            for l in range(3):
                if k == l:
                    continue

                if not (ok[i][j] & 1 << l):
                    continue

                if dp[j][l] > 1 + dp[i][k]:
                    dp[j][l] = 1 + dp[i][k]
                    last[j][l] = (i, k)

cur = (n, 0)
for k in range(3):
    if dp[n][k] < dp[cur[0]][cur[1]]:
        cur = (n, k)

if dp[cur[0]][cur[1]] == INF:
    print(-1)
    sys.exit(0)


print(dp[cur[0]][cur[1]])

ans = []

while cur[0] != 0:
    nxt = last[cur[0]][cur[1]]
    ans.append((nxt[0], cur[0], cur[1]))
    cur = nxt

for p in reversed(ans):
    print(p[0], p[1], names[p[2]])
