#!/usr/bin/env python3

# Input validator
# Does NOT verify condition of subtask 3

import sys

st = {2, 3, 4}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline())
if 1 > n or n > 1e5:
	sys.exit('N out of range')
fo.write(f'{n}\n')
if n > 1e4:
	st.discard(2)

p = set()

for i in range(n):
	x, y = (int(x) for x in fi.readline().split())
	if 0 > x or x > 1e9:
		sys.exit(f'X[{1 + i}] out of range')
	if 0 > y or y > 1e9:
		sys.exit(f'Y[{1 + i}] out of range')
	if (x, y) in p:
		sys.exit(f'Duplicate position {x} {y}')
	p.add((x, y))
	fo.write(f'{x} {y}\n')

x, y = (int(x) for x in fi.readline().split())
if 0 > x or x > 1e9:
	sys.exit(f'Xr out of range')
if 0 > y or y > 1e9:
	sys.exit(f'Yr out of range')
if (x, y) in p:
	sys.exit(f'Duplicate position {x} {y}')
p.add((x, y))
fo.write(f'{x} {y}\n')

x, y = (int(x) for x in fi.readline().split())
if 0 > x or x > 1e9:
	sys.exit(f'Xv out of range')
if 0 > y or y > 1e9:
	sys.exit(f'Yv out of range')
if (x, y) in p:
	sys.exit(f'Duplicate position {x} {y}')
p.add((x, y))
fo.write(f'{x} {y}\n')

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
	print('subtasks:', *st)
